---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "decort_cb_k8s_cp Resource - terraform-provider-decort"
subcategory: ""
description: |-
  
---

# decort_cb_k8s_cp (Resource)





<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `k8sci_id` (Number) ID of the k8s catalog item to base this instance on.
- `name` (String) Name of the cluster.
- `network_plugin` (String) Network plugin to be used
- `rg_id` (Number) Resource group ID that this instance belongs to.

### Optional

- `additional_sans` (List of String) Optional extra Subject Alternative Names (SANs) to use for the API Server serving certificate. Can be both IP addresses and DNS names
- `chipset` (String) Type of the emulated system.
- `cluster_config` (String) is used to define global settings and configurations for the entire cluster. It includes parameters such as cluster name, DNS settings, authentication methods, and other cluster-wide configurations. insert a valid JSON string with all levels of nesting.
- `cpu` (Number) Node CPU count.
- `desc` (String) Text description of this instance.
- `disk` (Number) Node boot disk size in GB.
- `enabled` (Boolean) Enable k8s cluster
- `extnet_id` (Number) ID of the external network to connect workers to. If omitted network will be chosen by the platfom.
- `extnet_only` (Boolean) Use only selected ExtNet for infrastructure connections
- `ha_mode` (Boolean) Use Highly Available schema for LB deploy
- `init_config` (String) is used to define settings and actions that should be performed before any other component in the cluster starts. It allows you to configure things like node registration, network setup, and other initialization tasks. insert a valid JSON string with all levels of nesting.
- `join_config` (String) is used to configure the behavior and settings for joining a node to a cluster. It includes parameters such as the cluster's control plane endpoint, token, and certificate key. insert a valid JSON string with all levels of nesting.
- `kube_proxy_config` (String) is used to configure the behavior and settings of the Kube-proxy, which is responsible for network proxying and load balancing within the cluster. It includes parameters such as proxy mode, cluster IP ranges, and other Kube-proxy specific configurations. insert a valid JSON string with all levels of nesting.
- `kubelet_config` (String) is used to configure the behavior and settings of the Kubelet, which is the primary node agent that runs on each node in the cluster. It includes parameters such as node IP address, resource allocation, pod eviction policies, and other Kubelet-specific configurations. insert a valid JSON string with all levels of nesting.
- `lb_sysctl_params` (List of Map of String) Custom sysctl values for Load Balancer instance. Applied on boot.
- `num` (Number) Number of VMs to create. Can be either 1 or 3 or 5
- `oidc_cert` (String) insert ssl certificate in x509 pem format
- `permanently` (Boolean) whether to completely delete the account
- `ram` (Number) Node RAM in MB.
- `restore` (Boolean)
- `sep_id` (Number) Storage Endpoint ID
- `sep_pool` (String) Storage Endpoint Pool
- `start` (Boolean) Start k8s cluster.
- `timeouts` (Block, Optional) (see [below for nested schema](#nestedblock--timeouts))
- `vins_id` (Number) ID of default vins for this instace.
- `with_lb` (Boolean) Create k8s with load balancer if true.

### Read-Only

- `account_id` (Number)
- `account_name` (String)
- `acl` (List of Object) (see [below for nested schema](#nestedatt--acl))
- `bservice_id` (Number)
- `created_by` (String)
- `created_time` (Number)
- `default_wg_id` (Number) ID of default workers group for this instace.
- `deleted_by` (String)
- `deleted_time` (Number)
- `detailed_info` (List of Object) (see [below for nested schema](#nestedatt--detailed_info))
- `gid` (Number)
- `guid` (Number)
- `id` (String) The ID of this resource.
- `k8s_ci_name` (String)
- `k8s_id` (Number)
- `kubeconfig` (String) Kubeconfig for cluster access.
- `lb_id` (Number)
- `lb_ip` (String) IP address of default load balancer.
- `master_id` (Number) Master group ID.
- `master_name` (String) Master group name.
- `milestones` (Number)
- `rg_name` (String)
- `ssh_key` (String)
- `status` (String)
- `tech_status` (String)
- `updated_by` (String)
- `updated_time` (Number)

<a id="nestedblock--timeouts"></a>
### Nested Schema for `timeouts`

Optional:

- `create` (String)
- `default` (String)
- `delete` (String)
- `read` (String)
- `update` (String)


<a id="nestedatt--acl"></a>
### Nested Schema for `acl`

Read-Only:

- `account_acl` (List of Object) (see [below for nested schema](#nestedobjatt--acl--account_acl))
- `k8s_acl` (List of Object) (see [below for nested schema](#nestedobjatt--acl--k8s_acl))
- `rg_acl` (List of Object) (see [below for nested schema](#nestedobjatt--acl--rg_acl))

<a id="nestedobjatt--acl--account_acl"></a>
### Nested Schema for `acl.account_acl`

Read-Only:

- `explicit` (Boolean)
- `guid` (String)
- `right` (String)
- `status` (String)
- `type` (String)
- `user_group_id` (String)


<a id="nestedobjatt--acl--k8s_acl"></a>
### Nested Schema for `acl.k8s_acl`

Read-Only:

- `explicit` (Boolean)
- `guid` (String)
- `right` (String)
- `status` (String)
- `type` (String)
- `user_group_id` (String)


<a id="nestedobjatt--acl--rg_acl"></a>
### Nested Schema for `acl.rg_acl`

Read-Only:

- `explicit` (Boolean)
- `guid` (String)
- `right` (String)
- `status` (String)
- `type` (String)
- `user_group_id` (String)



<a id="nestedatt--detailed_info"></a>
### Nested Schema for `detailed_info`

Read-Only:

- `compute_id` (Number)
- `interfaces` (List of Object) (see [below for nested schema](#nestedobjatt--detailed_info--interfaces))
- `name` (String)
- `status` (String)
- `tech_status` (String)

<a id="nestedobjatt--detailed_info--interfaces"></a>
### Nested Schema for `detailed_info.interfaces`

Read-Only:

- `def_gw` (String)
- `ip_address` (String)
