---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "decort_kvmvm Resource - terraform-provider-decort"
subcategory: ""
description: |-
  
---

# decort_kvmvm (Resource)





<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `cpu` (Number) Number of CPUs to allocate to this compute instance.
- `driver` (String) Hardware architecture of this compute instance.
- `name` (String) Name of this compute. Compute names are case sensitive and must be unique in the resource group.
- `ram` (Number) Amount of RAM in MB to allocate to this compute instance.
- `rg_id` (Number) ID of the resource group where this compute should be deployed.

### Optional

- `affinity_label` (String) Set affinity label for compute
- `affinity_rules` (Block List) (see [below for nested schema](#nestedblock--affinity_rules))
- `anti_affinity_rules` (Block List) (see [below for nested schema](#nestedblock--anti_affinity_rules))
- `auto_start` (Boolean) Flag for redeploy compute
- `boot_disk_size` (Number) This compute instance boot disk size in GB. Make sure it is large enough to accomodate selected OS image.
- `cd` (Block Set, Max: 1) (see [below for nested schema](#nestedblock--cd))
- `chipset` (String) Type of the emulated system.
- `cloud_init` (String) Optional cloud_init parameters. Applied when creating new compute instance only, ignored in all other cases.
- `cpu_pin` (Boolean) Run VM on dedicated CPUs. To use this feature, the system must be pre-configured by allocating CPUs on the physical node.
- `custom_fields` (String)
- `data_disks` (String) Flag for redeploy compute
- `description` (String) Optional text description of this compute instance.
- `detach_disks` (Boolean)
- `disks` (Block List) (see [below for nested schema](#nestedblock--disks))
- `enabled` (Boolean) If true - enable compute, else - disable
- `extra_disks` (Set of Number) Optional list of IDs of extra disks to attach to this compute. You may specify several extra disks.
- `force_resize` (Boolean) Flag for resize compute
- `force_stop` (Boolean) Flag for redeploy compute
- `hp_backed` (Boolean) Use Huge Pages to allocate RAM of the virtual machine. The system must be pre-configured by allocating Huge Pages on the physical node.
- `image_id` (Number) ID of the OS image to base this compute instance on.
- `ipa_type` (String) compute purpose
- `is` (String) system name
- `network` (Block Set, Max: 8) Optional network connection(s) for this compute. You may specify several network blocks, one for each connection. (see [below for nested schema](#nestedblock--network))
- `numa_affinity` (String) Rule for VM placement with NUMA affinity.
- `pause` (Boolean)
- `pci_devices` (Set of Number) ID of the connected pci devices
- `permanently` (Boolean)
- `pin_to_stack` (Boolean)
- `pool` (String) Pool to use if sepId is set, can be also empty if needed to be chosen by system.
- `port_forwarding` (Block Set) (see [below for nested schema](#nestedblock--port_forwarding))
- `reset` (Boolean)
- `restore` (Boolean)
- `rollback` (Block Set, Max: 1) (see [below for nested schema](#nestedblock--rollback))
- `sep_id` (Number) ID of SEP to create bootDisk on. Uses image's sepId if not set.
- `snapshot` (Block Set) (see [below for nested schema](#nestedblock--snapshot))
- `snapshot_delete_async` (Boolean)
- `started` (Boolean) Is compute started.
- `stateless` (Boolean) Compute will be stateless (SVA_KVM_X86) if set to True
- `tags` (Block Set) (see [below for nested schema](#nestedblock--tags))
- `timeouts` (Block, Optional) (see [below for nested schema](#nestedblock--timeouts))
- `user_access` (Block Set) (see [below for nested schema](#nestedblock--user_access))
- `without_boot_disk` (Boolean) If True, the imageId, bootDisk, sepId, pool parameters are ignored and the compute is created without a boot disk in the stopped state.

### Read-Only

- `account_id` (Number) ID of the account this compute instance belongs to.
- `account_name` (String) Name of the account this compute instance belongs to.
- `affinity_weight` (Number)
- `arch` (String)
- `boot_disk` (Set of Object) (see [below for nested schema](#nestedatt--boot_disk))
- `boot_disk_id` (Number) This compute instance boot disk ID.
- `boot_order` (List of String)
- `cd_image_id` (Number)
- `clone_reference` (Number)
- `clones` (List of Number)
- `compute_id` (Number)
- `computeci_id` (Number)
- `created_by` (String)
- `created_time` (Number)
- `deleted_by` (String)
- `deleted_time` (Number)
- `devices` (String)
- `gid` (Number)
- `guid` (Number)
- `id` (String) The ID of this resource.
- `interfaces` (List of Object) (see [below for nested schema](#nestedatt--interfaces))
- `lock_status` (String)
- `manager_id` (Number)
- `manager_type` (String)
- `migrationjob` (Number)
- `milestones` (Number)
- `natable_vins_id` (Number)
- `natable_vins_ip` (String)
- `natable_vins_name` (String)
- `natable_vins_network` (String)
- `natable_vins_network_name` (String)
- `need_reboot` (Boolean)
- `numa_node_id` (Number)
- `os_users` (List of Object) Guest OS users provisioned on this compute instance. (see [below for nested schema](#nestedatt--os_users))
- `pinned` (Boolean)
- `reference_id` (String)
- `registered` (Boolean)
- `res_name` (String)
- `reserved_node_cpus` (List of Number)
- `rg_name` (String) Name of the resource group where this compute instance is located.
- `snap_sets` (List of Object) (see [below for nested schema](#nestedatt--snap_sets))
- `stateless_sep_id` (Number)
- `stateless_sep_type` (String)
- `status` (String)
- `tech_status` (String)
- `updated_by` (String)
- `updated_time` (Number)
- `user_managed` (Boolean)
- `vgpus` (List of Object) (see [below for nested schema](#nestedatt--vgpus))
- `virtual_image_id` (Number)
- `virtual_image_name` (String)

<a id="nestedblock--affinity_rules"></a>
### Nested Schema for `affinity_rules`

Required:

- `key` (String) key that are taken into account when analyzing this rule will be identified
- `mode` (String) EQ or NE or ANY - the comparison mode is 'value', recorded by the specified 'key'
- `policy` (String) RECOMMENDED or REQUIRED, the degree of 'strictness' of this rule
- `topology` (String) compute or node, for whom rule applies

Optional:

- `value` (String) value that must match the key to be taken into account when analyzing this rule


<a id="nestedblock--anti_affinity_rules"></a>
### Nested Schema for `anti_affinity_rules`

Required:

- `key` (String) key that are taken into account when analyzing this rule will be identified
- `mode` (String) EQ or NE or ANY - the comparison mode is 'value', recorded by the specified 'key'
- `policy` (String) RECOMMENDED or REQUIRED, the degree of 'strictness' of this rule
- `topology` (String) compute or node, for whom rule applies

Optional:

- `value` (String) value that must match the key to be taken into account when analyzing this rule


<a id="nestedblock--cd"></a>
### Nested Schema for `cd`

Required:

- `cdrom_id` (Number)


<a id="nestedblock--disks"></a>
### Nested Schema for `disks`

Required:

- `disk_name` (String) Name for disk
- `size` (Number) Disk size in GiB

Optional:

- `desc` (String) Optional description
- `disk_type` (String) The type of disk in terms of its role in compute: 'B=Boot, D=Data'
- `image_id` (Number) Specify image id for create disk from template
- `permanently` (Boolean) Disk deletion status
- `pool` (String) Pool name; by default will be chosen automatically
- `sep_id` (Number) Storage endpoint provider ID; by default the same with boot disk

Read-Only:

- `disk_id` (Number) Disk ID
- `shareable` (Boolean)
- `size_max` (Number)
- `size_used` (Number)


<a id="nestedblock--network"></a>
### Nested Schema for `network`

Required:

- `net_id` (Number) ID of the network for this connection.
- `net_type` (String) Type of the network for this connection, either EXTNET or VINS.

Optional:

- `ip_address` (String) Optional IP address to assign to this connection. This IP should belong to the selected network and free for use.
- `mtu` (Number) Maximum transmission unit, used only for DPDK type, must be 1-9216
- `weight` (Number) weight the network if you need to sort network list, the smallest attach first. zero or null weight attach last

Read-Only:

- `mac` (String) MAC address associated with this connection. MAC address is assigned automatically.


<a id="nestedblock--port_forwarding"></a>
### Nested Schema for `port_forwarding`

Required:

- `proto` (String)
- `public_port_start` (Number)

Optional:

- `local_port` (Number)
- `public_port_end` (Number)


<a id="nestedblock--rollback"></a>
### Nested Schema for `rollback`

Required:

- `label` (String)


<a id="nestedblock--snapshot"></a>
### Nested Schema for `snapshot`

Required:

- `label` (String)


<a id="nestedblock--tags"></a>
### Nested Schema for `tags`

Required:

- `key` (String)
- `value` (String)


<a id="nestedblock--timeouts"></a>
### Nested Schema for `timeouts`

Optional:

- `create` (String)
- `default` (String)
- `delete` (String)
- `read` (String)
- `update` (String)


<a id="nestedblock--user_access"></a>
### Nested Schema for `user_access`

Required:

- `access_type` (String)
- `username` (String)


<a id="nestedatt--boot_disk"></a>
### Nested Schema for `boot_disk`

Read-Only:

- `desc` (String)
- `disk_id` (Number)
- `disk_name` (String)
- `disk_type` (String)
- `image_id` (Number)
- `permanently` (Boolean)
- `pool` (String)
- `sep_id` (Number)
- `shareable` (Boolean)
- `size` (Number)
- `size_max` (Number)
- `size_used` (Number)


<a id="nestedatt--interfaces"></a>
### Nested Schema for `interfaces`

Read-Only:

- `bus_number` (Number)
- `conn_id` (Number)
- `conn_type` (String)
- `def_gw` (String)
- `enabled` (Boolean)
- `flip_group_id` (Number)
- `guid` (String)
- `ip_address` (String)
- `libvirt_settings` (List of Object) (see [below for nested schema](#nestedobjatt--interfaces--libvirt_settings))
- `listen_ssh` (Boolean)
- `mac` (String)
- `mtu` (Number)
- `name` (String)
- `net_id` (Number)
- `net_type` (String)
- `netmask` (Number)
- `node_id` (Number)
- `pci_slot` (Number)
- `qos` (List of Object) (see [below for nested schema](#nestedobjatt--interfaces--qos))
- `target` (String)
- `type` (String)
- `vnfs` (List of Number)

<a id="nestedobjatt--interfaces--libvirt_settings"></a>
### Nested Schema for `interfaces.libvirt_settings`

Read-Only:

- `event_idx` (String)
- `guid` (String)
- `ioeventfd` (String)
- `queues` (Number)
- `rx_queue_size` (Number)
- `tx_queue_size` (Number)
- `txmode` (String)


<a id="nestedobjatt--interfaces--qos"></a>
### Nested Schema for `interfaces.qos`

Read-Only:

- `e_rate` (Number)
- `guid` (String)
- `in_brust` (Number)
- `in_rate` (Number)



<a id="nestedatt--os_users"></a>
### Nested Schema for `os_users`

Read-Only:

- `guid` (String)
- `login` (String)
- `password` (String)
- `public_key` (String)


<a id="nestedatt--snap_sets"></a>
### Nested Schema for `snap_sets`

Read-Only:

- `disks` (List of Number)
- `guid` (String)
- `label` (String)
- `timestamp` (Number)


<a id="nestedatt--vgpus"></a>
### Nested Schema for `vgpus`

Read-Only:

- `account_id` (Number)
- `bus_number` (Number)
- `created_time` (Number)
- `deleted_time` (Number)
- `gid` (Number)
- `guid` (Number)
- `id` (Number)
- `last_claimed_by` (Number)
- `last_update_time` (Number)
- `mode` (String)
- `pci_slot` (Number)
- `pgpuid` (Number)
- `profile_id` (Number)
- `ram` (Number)
- `reference_id` (String)
- `rg_id` (Number)
- `status` (String)
- `type` (String)
- `vmid` (Number)
