/*
Ресурс образа из платформенного диска позволяет:
1. Создавать
2. Редактировать
3. Удалять ресурс
*/

#Расскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://ds1.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_image_from_platform_disk" "img" {
  #id диска
  #используется для создания образа
  #обязательный параметр
  #тип - целое число
  disk_id = 1234

  #наименование образа
  #используется для создания и обновления образа
  #обязательный параметр
  #тип - строка
  name = "image_name"

  #тип загрузчика
  #используется для создания образа
  #обязательный параметр
  #возможные значения - bios, uefi
  #тип - строка
  boot_type = "bios"

  #тип образа (linux, windows и др.)
  #используется для создания образа
  #обязательный параметр
  #тип - строка
  type = "linux"

  #архитектура образа
  #используется для создания образа
  #обязательный параметр
  #возможные значения - X86_64
  #тип - строка
  architecture = "X86_64"

  #драйверы компьютов, подходящие для данного образа
  #используется для создания образа
  #обязательный параметр
  #тип - массив строк
  drivers = ["KVM_X86"]

  #имя пользователя для образа
  #используется для создания образа
  #опциональный параметр
  #тип - строка
  #username = "userx"

  #пароль для образа
  #используется для создания образа
  #опциональный параметр
  #тип - строка
  #password = "passx"

  #id аккаунта
  #используется для создания образа
  #опциональный параметр
  #тип - целое число
  #account_id = 138

  #id сепа для образа
  #используется для создания образа
  #опциональный параметр
  #тип - целое число
  #sep_id = 1

  #pool для образа
  #используется для создания образа
  #опциональный параметр
  #тип - строка
  #pool_name = "pool"

  #поддержка hot resize
  #используется для создания образа
  #опциональный параметр
  #тип - булев
  #hot_resize = true

  #флаг загрузочного образа
  #используется для создания образа
  #опциональный параметр
  #по умолчанию - true
  #тип - булев
  #bootable = true

  #флаг для создания образа в асинхронном режиме
  #опциональный параметр
  #по умолчанию - false
  #тип - булев
  #async_mode = true

}

output "img_out" {
  value = decort_image_from_platform_disk.img
}