/*
Пример использования
Управление snapshot
Ресурс позволяет:
1. Создавать snapshot
2. Удалять snapshot
3. Откатывать snapshot
*/

#Расскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source  = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://ds1.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_snapshot" "s" {
  #обязательный параметр
  #id вычислительной мощности
  #тип - целое число
  compute_id = 24074

  #обязательный параметр
  #наименование snapshot
  #тип - строка
  label = "test_ssht_3"

  #флаг отката
  #опциональный параметр
  #если флаг был измеен с false на true, то произойдет откат
  #по-уолчанию - false
  #тип - булев
  rollback = false

  #флаг для удаление снапшота асинхронном режиме
  #опциональный параметр
  #по умолчанию - false
  #тип - булев
  delete_async_mode = true

}

output "test" {
  value = decort_snapshot.s
}
