/*
Пример использования
Ресурса диска:
1. Создание ресурса
2. Изменение ресурса
3. Удаление ресурса
*/

#Раскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером

/*
terraform {
  required_providers {
    decort = {
      source  = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator        = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url       = "https://ds1.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_cb_dpdknet" "dpdk" {
  #название
  #обязательный параметр
  #тип - строка
  name = "dpdk-name"

  #gid
  #обязательный параметр
  #тип - целое число
  gid = 212

  #vlanid для тегирования траффика на интерфейсе для компьюта
  #обязательный параметр
  #тип - целое число
  vlan_id = 123

  #OVS bridge в котором будут создаваться интерфейсы для компьютов, созданные из этой сети
  #обязательный параметр
  #тип - строка
  ovs_bridge = "OVSBridge"

  #описание сети
  #опциональный параметр
  #тип - строка
  #desc = "description"

  #список id аккаунтов, которым может быть выделена сеть в эксклюзивное пользование
  #опциональный параметр
  #тип - массив целых чисел
  #account_access = [10,11]

  #список id ресурсных групп, которым может быть выделена сеть в эксклюзивное пользование
  #опциональный параметр
  #тип - массив целых чисел
  #rg_access = [10,11]

  #флаг доступности сети для проведения с ней операций
  #опциональный параметр
  #по умолчанию - false
  #тип - булев
  #enabled = true
}

output "test" {
  value = decort_cb_dpdknet.dpdk
}
