/*
Ресурс образа из платформенного диска:
1. Создавать
2. Редактировать
3. Удалять ресурс
*/

#Расскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source  = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://ds1.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_cb_image_from_platform_disk" "my_image" {
  #ID платформенного диска
  #используется для создания образа
  #обязательный параметр
  #тип - целое число
  disk_id = 1234

  #имя образа
  #используется для обновления и создания образа
  #обязательный параметр
  #тип - строка
  #при изменении - изменяет название созданного образа
  name = "test_image_rename"

  #тип загрузки образа
  #используется для создания образа
  #обязательный параметр
  #тип - строка
  #возможные варианты: "bios" или "uefi"
  boot_type = "bios"

  #тип образа
  #используется для создания образа
  #обязательный параметр
  #тип - строка
  #возможные варианты - "linux", "windows"
  image_type = "linux"

  #архитектура образа
  #используется для создания образа
  #обязательный параметр
  #возможные значения - X86_64
  #тип - строка
  architecture = "X86_64"

  #драйверы компьютов, подходящие для данного образа
  #используется для создания образа
  #обязательный параметр
  #тип - массив строк
  drivers = ["KVM_X86"]

  #имя пользователя для образа
  #используется для обновления и создания образа
  #опциональный параметр
  #тип - строка
  #username = "userx"

  #пароль для образа
  #используется для обновления и создания образа
  #опциональный параметр
  #тип - строка
  #password = "passx"

  #ID аккаунта
  #используется для обновления и создания образа
  #опциональный параметр
  #тип - целое число
  #account_id = 138

  #sep id
  #используется для создания образа
  #опциональный параметр
  #тип - целое число
  #sep_id = 1

  #название pool
  #используется для создания образа
  #опциональный параметр
  #тип - строка
  #pool_name = "pool"

  #поддержка hot resize
  #используется для обновления и создания образа
  #опциональный параметр
  #тип - булев
  #hot_resize = true

  #является ли образ загрузочным 
  #опциональный параметр, используется на уже созданном ресурсе или при создании ресурса
  #тип - булев
  #bootable = true

  #флаг для создания образа в асинхронном режиме
  #опциональный параметр
  #по умолчанию - false
  #тип - булев
  #async_mode = true

  #доступность образа
  #опциональный параметр, используется на уже созданном ресурсе
  #тип - булев
  #enabled = true

  #настройка доступа образа аккаунтам
  #опциональный параметр, используется на уже созданном ресурсе
  #тип - массив целых чисел
  #пустой массив - удаление всех доступов, если они были
  #shared_with = [28096, 57121]

  #установка computeci
  #опциональный параметр, используется на уже созданном ресурсе
  #тип - целое число
  #чтобы сбросить, необходимо передать 0
  #computeci_id = 1

  #доступные стаки
  #опциональный параметр, используется на уже созданном ресурсе
  #тип - массив целых чисел
  #для удаления всех доступных стаков, необходимо передать пустой массив
  #enabled_stacks = [9]

  #аккаунты, которым предоставляется доступ к образу
  #Используется для обновления и создания образа
  #опциональный параметр
  #тип - массив целых чисел
  #для удаления всех доступных аккаунтов, необходимо передать пустой массив
  #accounts = [9, 5]

  #наименование сетевого интерфейса для вашего компьютера с Linux, eth - встроенный, ens - pci слот
  #используется для обновления образа
  #опциональный параметр
  #тип - строка
  #network_interface_naming = "ens"
}

output "test" {
  value = decort_cb_image_from_platform_disk.my_image
}
