/*
Пример использования
Ресурса virtual image
Ресурс позволяет:
1. Создавать образ
2. Редактировать образ
3. Удалять образ
*/

#Расскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source  = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://ds1.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_cb_virtual_image" "my_image" {
  #имя виртуального образа
  #обязательный параметр
  #тип - строка
  name = "test_vi_im_new_rename"

  #id образа, на основе котрого будет создан виртуальный
  #обязательный параметр
  #может быть также использован при редактировании
  #тип - целое число
  link_to = 6125

  #id аккаунта владельца образа
  #опциональный параметр
  #может быть использован при редактировании образа
  #тип данных - целое число
  #account_id = 57252

  #является ли образ загрузочным 
  #опциональный параметр
  #используется на уже созданном ресурсе
  #тип - булев
  #bootable = true

  #поддержка hot resize
  #опциональный параметр
  #тип - булев
  #hot_resize = true

  #имя пользователя
  #опциональный параметр
  #может быть использован при редактировании образа
  #тип - строка
  #username = "Valera"

  #пароль пользователя
  #опциональный параметр
  #может быть использован при редактировании образа
  #тип - строка
  #password = "123"

  #доступность образа
  #опциональный параметр
  #используется на уже созданном ресурсе
  #тип - булев
  #enabled = false

  #настройка доступа образа аккаунтам
  #опциональный параметр
  #используется на уже созданном ресурсе
  #пустой маасив - удаление всех доступов, если они были
  #тип - массив целых чисел
  #shared_with = [28096, 57121]

  #установка computeci
  #опциональный параметр, используется на уже созданном ресурсе
  #чтобы сбросить, необходимо передать 0
  #тип - целое число
  #computeci_id = 1

  #доступные стаки
  #опциональный параметр, используется на уже созданном ресурсе
  #для удаления всех доступных стаков, необходимо передать пустой массив
  #тип - массив целых чисел
  #enabled_stacks = [9]
  
}

output "test" {
  value = decort_cb_virtual_image.my_image
}
