/*
Пример использования
Ресурса k8ci
Ресурс позволяет:
1. Создавать k8ci
2. Редактировать k8ci
3. Удалять k8ci
*/

#Расскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source  = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://ds1.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_cb_k8ci" "k8ci" {
  #имя k8ci
  #обязательный параметр
  #тип - строка
  name = "test"

  #тег версии
  #обязательный параметр
  #тип - строка
  version = "1.1.1"

  #тип master driver
  #обязательный параметр
  #тип - строка
  master_driver = "KVM_X86"

  #тип worker driver
  #обязательный параметр
  #тип - строка
  worker_driver = "KVM_X86"

  #максимальное число master компутов
  #обязательный параметр
  #тип - целое число
  max_master_count = 1

  #максимальное число worker компутов
  #обязательный параметр
  #тип - целое число
  max_worker_count = 1

  #id образа для master 
  #обязательный параметр
  #тип - целое число
  master_image_id = 4

  #id образа для worker 
  #обязательный параметр
  #тип - целое число
  worker_image_id = 4

  #network plugins
  #обязательный параметр
  #тип - массив строк
  network_plugins = ["flannel"]

  #доступность k8ci
  #опциональный параметр
  #тип - булев
  #enabled = false

  #флаг для моментального удаления k8ci
  #опциональный параметр
  #тип - булев
  #permanently = true

  #описание 
  #опциональный параметр
  #тип - строка
  #desc =  "some"

  #доступность k8ci другим аккаунтам
  #опциональный параметр
  #тип - массив целых чисел
  #shared_with = [1111]

}

output "test" {
  value = decort_cb_k8ci.k8ci
}
