/*
Пример использования
Ресурс позволяет:
1. Создавать пул виртуальных сетевых функций
2. Изменять список аккаунтов, которым доступен пул
3. Изменять список ресурсных групп, которым доступен пул
4. Изменять статус пула
5. Изменять наименование или описание пула
6. Изменять конфигурацию пула
7. Удалять пул
*/

#Расскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source  = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://ds1.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_cb_vfpool" "vfpool" {
  #наименование vfpool
  #обязательный параметр
  #тип - строка
  name = "test"

  #описание vfpool
  #опциональный параметр
  #тип - строка
  #применяется при создании и редактировании ресурса
  #description = "some"

  #список для предоставления доступа к vfpool перечисленным аккаунтам
  #опциональный параметр
  #тип - массив целых чисел
  #применяется при создании и редактировании ресурса
  #account_access = [1,2]

  #список для предоставления доступа к vfpool перечисленным ресурсным группам
  #опциональный параметр
  #тип - массив целых чисел
  #применяется при создании и редактировании ресурса
  #rg_access = [1,2]

  #блок для указания списка конфигурации
  #опциональный параметр
  #тип - блок
  #config {
    #идентификатор узла
    #обязательный параметр
    #тип - целое число
    #node_id = 1

    #имя верхнеуровневого сетевого интерфейса, VF которого входят в пул
    #обязательный параметр
    #тип - строка
    #nic_name  = "eth0"

    #список идентификаторов VF для NIC узла
    #обязательный параметр
    #тип - массив целых чисел
    #vf_ids = [1,2]
  #}

  #ручное подключение и отключение ресурса
  #опциональный параметр
  #тип - булев
  #enable = true
}



