Так как платформа DECORT предоставляет для работы две группы API, то terraform провайдер позволяет свободно переключать режимы работы между этими группами.  
По умолчанию стоит пользовательская группа API. Ее можно сменить на административную группу.  
Если прав у пользователя будет достаточно, то запрос будет выполнен, если нет, то будет ошибка:
```bash
Permission denied
```
Которая говорит о том, что прав недостаточно. Тогда для выполнения операции обратитесь к администратору платформы.
Установка режима взаимодействия с группами API осуществляется через установку переменной окружения _DECORT_ADMIN_MODE_.
Для более подробного описания возможностей каждой группы API см. соответствующий раздел.

## Переключение режима работы в Windows
Используйте сл. команду:
```Powershell
$Env:DECORT_ADMIN_MODE=1
```
Для отключения:
```Powershell
$Env:DECORT_ADMIN_MODE=0
```
## Переключение режима работы в Linux
Используйте сл. команду:
```bash
DECORT_ADMIN_MODE=1
```
или
```bash
export DECORT_ADMIN_MODE=1
```
Для отключения:
```bash
DECORT_ADMIN_MODE=0
```
или 
```bash
export DECORT_ADMIN_MODE=0
```
**ОБРАТИТЕ ВНИМАНИЕ**  
Переменные окружения создаются для терминальной сессии. В сл. раз их придется задавать еще раз, если требуется режим, отличный от пользовательского.
