Функция доступна в провайдере версии 2.0 и выше.

_Data source_ функция **decort_image_list_stacks** служит для получения информации об имеющихся в облачной платформе доступных образу stacks. Образы это дисковые ресурсы, уже содержащие некоторые данные, для которых реализован механизм быстрого клонирования/копирования в новый диск. Stacks - единица платформы, в которой хранятся в том числе и образы. Из других stacks к образу доступа нет.

## Аргументы
_Data source_ функция **decort_image_list_stacks** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| image_id | int | :heavy_check_mark: | ID образа |
| page | int | :x: | Номер страницы |
| size | int | :x: | Размер страницы |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_image_list_stacks** возвращает в указанную при вызове переменную, в поле _items_, массив, каждый элемент которого состоит из следующих параметров:
| Параметр | Тип | Описание |
| --- | --- | --- |
| api_key | string | Ключ api |
| api_url | string | Адрес api |
| app_id | string | ID приложения |
| desc | string | Описание |
| drivers | []string | Список драйверов |
| error | int | Номер ошибки |
| guid | int | Внутренний id |
| id | int | ID |
| images | []int | Список доступных образов на stack | 
| login | string | Логин пользователя |
| name | string | Наименование stacks |
| passwd | string | Пароль |
| reference_id | string | ID ссылки |
| status | string | Статус |
| type | string | Тип |

## Пример использования
Пример вызова _data source_ функции **decort_image_list_stacks**:
```terraform
data "decort_image_list_stacks" "ils" {
  image_id = 1234
  #page = 2
  #size = 3
}
# once the above directive completes,  will be accessible 
# as data.decort_image_list_stacks.ils.items
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_image_list_stacks** в переменной `data.decort_image_list_stacks.ils` будут сохранены возвращаемые значения.
