Функция доступна в провайдере версии 3.2 и выше.

_Data source_ функция **decort_disk_snapshot_list** служит для получения списка снимков состояния диска.

## Аргументы
_Data source_ функция **decort_snapshot_list** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| disk_id | int | :heavy_check_mark: | ID диска для получения списка снимком состояния |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_disk_snapshot_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| label | string | Название снимка |
| guid | string | ID снимка |
| timestamp | int | Время снимка |
| res_id | string | Ссылка на снимок |
| snap_set_guid | string | ID набора снимков, в котором лежит снимок состояния |
| snap_set_time | string | Время набора |

## Пример использования
Пример вызова _data source_ функции **decort_disk_snapshot_list**:
```terraform
data "decort_disk_snapshot_list" "dsl" {
  #id диска для получения списка снимков
  #опциональный параметр 
  #тип - число
  #disk_id = 11111
}
# once the above directive completes, snapshot list will be accessible 
# as data.decort_disk_snapshot_list.dsl.items
```

После успешного завершения такого вызова **decort_disk_snapshot_list** в переменной `data.decort_disk_snapshot_list.dsl` будут сохранены возвращаемые значения.
