Функция доступна в провайдере версии 3.3 и выше.

_Data source_ функция **decort_vins_list_deleted** служит для получения списка удаленных виртуальных сетей (Vins).

## Аргументы

_Data source_ функция **decort_vins_list_deleted** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| by_id | int | :x: | Фильтр по ID ViNS |
| name | string | :x: | Фильтр по имени ViNS |
| account_id | int | :x: | Фильтр по ID аккаунта |
| rg_id | int | :x: | Фильтр по ID ресгруппы |
| ext_ip | string | :x: | Фильтр по внешнему IP адресу |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_vins_list_deleted** возвращает в указанную при вызове переменную, в поле items массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта - владельца виртуальной сети |
| account_name | string | Имя аккаунта - владельца виртуальной |
| created_by | string | Информация о создателе виртуальной сети |
| created_time | int | Время создания виртуальной сети |
| deleted_by | string | Информация о том, кто удалил виртуальную сеть |
| deleted_time | int | Время удаления виртуальной сети |
| external_ip | string | Внешний ip - адрес |
| vins_id | int | Идентификатор виртуальной сети |
| vins_name | string | Название виртуальной сети |
| network | string | Сеть |
| rg_id | int | Идентификатор ресурсной группы |
| rg_name | string | Название ресурсной группы |
| status | string | Статус виртуальной сети |
| updated_by | string | Кем виртуальная сеть была обновлена в последний раз |
| updated_time | int | Время последнего обновления |
| vxlan_id | int | Идентификатор vxlan |

## Пример использования

Пример вызова _data source_ функции **decort_vins_list_deleted**:

```terraform
data "decort_vins_list_deleted" "vins_list_deleted" {
  #кол-во страниц для вывода
  #опицональный параметр 
  #тип - число
  page = 1

  #размер страницы
  #опицональный параметр 
  #тип - число
  size = 1
}
```

После успешного завершения такого вызова **decort_vins_list_deleted** в переменной `data.decort_vins_list_deleted.vins_list_deleted` будут сохранены возвращаемые значения.

