_Data source_ функция **decort_k8ci_list** служит для получения информации о доступных k8ci

## Аргументы

| Аргумент | Тип | Обязательный | Описание |
| -------- | --- | ------------ | -------- |
| by_id | int | :x: | Фильтр по ID k8ci |
| name | string | :x: | Фильтр по имени |
| status | string | :x: | Фильтр по статусу |
| worker_driver | string | :x: | Фильтр по драйверу worker |
| master_driver | string | :x: | Фильтр по драйверу master |
| network_plugin | string | :x: | Фильтр по плагину сети (flannel, calico или weavenet) |
| include_disabled | bool | :x: | Дополнить рез-тат выключенными k8ci |
| page | int | :x: | Номер страницы |
| size | int | :x: | Размер страницы |

## Возвращаемые значения (в списке items)

| Параметр      | Тип      | Описание                                   |
| ------------    | -------  | ---------------------------------------- |
| k8ci_id         | int      | ID k8ci                                  |
| name            | string   | Наименование k8ci                        |
| lb_image_id     | int      | ID образа балансировщика                 |
| network_plugins | []string | Список доступных плагинов сети           |
| status          | string   | Статус                                   |
| desc            | string   | Описание                                 |
| created_time    | int      | Время создания                           |
| version         | string   | Версия                                   |

## Пример использования

```terraform
data "decort_k8ci_list" "k8ci_list" {
  # Фильтр по ID
  # Опциональный параметр
  # int
  by_id = 1

  # Номер страницы
  # Опциональный параметр
  # int
  page = 0

  # Размер страницы
  # Опциональный параметр
  # int
  size = 0
}
```

После успешного завершения такого вызова **decort_k8ci_list** в переменной `data.decort_k8ci_list.k8ci_list` будут сохранены возвращаемые значения.
