Функция доступна в версии провайдера 4.5.1 и выше.

_Data source_ функция **decort_cb_kvmvm** служит для получения информации об уже существующей в облачной платформе виртуальной машине (Virtual Machine, VM), созданной на базе системы виртуализации KVM.

## Аргументы
_Data source_ функция **decort_cb_kvmvm** принимает следующие аргументы:

| Аргумент | Тип    | Обязательный | Описание |
| --- |--------| --- | --- |
| compute_id | int    | :heavy_check_mark:| Идентификатор экземпляра _compute_, соответствующего данной виртуальной машине (подробнее о понятии _compute_ см. в разделе [Обзор облачной платформы DECORT](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.2/03.-Обзор-облачной-платформы-DECORT.md)). |
| reason | string | :x: | Причина вызова |

Пользователь облачной платформы, от лица которого происходит обращение к данной функции, должен иметь доступ к указанному виртуальному серверу и ресурсной группе. В противном случае возникнет ошибка доступа.

Пользователь облачной платформы задается на стадии инициализации Terraform провайдера DECORT (см. [подробности](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_kvmvm** возвращает в указанную при вызове переменную следующие значения:

| Параметр | Тип                                                     | Описание                                                                                                                                                                      |
| --- |---------------------------------------------------------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| account_id | int                                                     | Уникальный идентификатор подписчика-владельца ("account") данной виртуальной машины.                                                                                          |
| account_name | string                                                  | Имя подписчика, которому принадлежит данная виртуальная машина.                                                                                                               |
| acl | []Struct [см. ниже](#описание-структуры-acl)            | Cписок Acces Control                                                                                                                                                          |
| affinity_label | string                                                  | Лейбл аффинити                                                                                                                                                                |
| affinity_rules | []Struct [см. ниже](#описание-структуры-affinity-rules) | Правила аффинити для компьютов                                                                                                                                                |
| affinity_weight | int                                                     | weight аффинити                                                                                                                                                               |
| anti_affinity_rules | []Struct [см. ниже](#описание-структуры-affinity-rules) | Правила анти аффинити для компьютов                                                                                                                                           |
| arch | string                                                  | Архитектура                                                                                                                                                                   |
| boot_order | []string                                                | Boot order                                                                                                                                                                    |
|cd_image_id| int                                                     | cd image id                                                                                                                                                                   |
| clone_reference | int                                                     | кол-во клонов                                                                                                                                                                 |
| clones | []int                                                   | id клонов                                                                                                                                                                     |
| compute_id | int                                                     | Идентификатор экземпляра _compute_, соответствующего данной виртуальной машине.                                                                                               |
| computeci_id | int                                                     | ID вычислительного ресурса                                                                                                                                                    |
| cpus | int                                                     | Количество виртуальных CPU, выделенных данному серверу.                                                                                                                       |
| created_by | string                                                  | Кем создан _compute_                                                                                                                                                          |
| created_time | int                                                     | Время создания _compute_                                                                                                                                                      |
| custom_fields | string                                                  | Кастомные поля                                                                                                                                                                |
| deleted_by | string                                                  | Кем удален _compute_                                                                                                                                                          |
| deleted_time | int                                                     | Время удаления _compute_                                                                                                                                                      |
| desc | string                                                  | Текстовое описание виртуальной машины.                                                                                                                                        |
| devices | string                                                  | Девайсы                                                                                                                                                                       |
| disks | []Struct [см. ниже](#описание-структуры-disks)          | информация о дисках компьюта                                                                                                                                                  |
| driver | string                                                  | Аппаратная архитектура данной виртуальной машины.                                                                                                                             |
| gid | int                                                     | GRID ID                                                                                                                                                                       |
| guid | int                                                     | ID ресурса                                                                                                                                                                    |
| image_id | int                                                     | Идентификатор образа ОС, на базе которого создан загрузочный диск этой виртуальной машины.                                                                                    |
| interfaces | []Struct [см. ниже](#описание-структуры-interfaces)     | Информация о интерфейсах компьюта                                                                                                                                             |
| lock_status | string                                                  | Статус доступности                                                                                                                                                            |
| manager_id | int                                                     | Manager id                                                                                                                                                                    |
| manager_type | string                                                  | Type manager                                                                                                                                                                  |
| migrationjob | int                                                     | Migrationjob                                                                                                                                                                  |
| milestones | int                                                     | Вехи                                                                                                                                                                          |
| name | string                                                  | Имя компьюта                                                                                                                                                                  |
| need_reboot                  | bool                                                    | Флаг перезапуска                                                                                                                                                              |
| os_users                  | []Struct [см. ниже](#описание-структуры-os-users)       | Имена и пароли пользователей гостевой ОС, установленные платформой при создании виртуального сервера.                                                                         |
| pinned | bool                                                    | добавлен ли компьют на стек                                                                                                                                                   |
| ram | int                                                     | Объём оперативной памяти в МБ, выделенной этой виртуальной машине.                                                                                                            |
| reference_id | string                                                  | ID ссылки                                                                                                                                                                     |
| registered | bool                                                    | Компьют зарегестрирован                                                                                                                                                       |
| res_name | string                                                  | Наименование ресурса                                                                                                                                                          |
| rg_id | int                                                     | Идентификатор ресурсной группы, к которой принадлежит виртуальная машина.                                                                                                     |
| rg_name | string                                                  | Имя ресурсной группы, к которой принадлежит виртуальная машина.                                                                                                               |
| snap_sets | []Struct [см. ниже](#описание-структуры-snap-sets)      | Snap sets                                                                                                                                                                     |
| stack_id    | int                                                     | id стэка                                                                                                                                                                      |
|    stack_name      | string                                                  | Название стэка                                                                                                                                                                |
| stateless_sep_id | int                                                     | ID сеп                                                                                                                                                                        |
| stateless_sep_type | string                                                  | Тип сеп                                                                                                                                                                       |
| status | string                                                  | Статус компьюта                                                                                                                                                               |
| tags | []Struct [см. ниже](#описание-структуры-tags)           | Тэги                                                                                                                                                                          |
| tech_status | string                                                  | Технический статус компьюта в составе группы                                                                                                                                  |
| updated_by | string                                                  | Кем компьют был обновлен                                                                                                                                                      |
| updated_time | int                                                     | Время последнего обновления                                                                                                                                                   |
|user_data| string                                                  | Данные пользователя                                                                                                                                                           |
| user_managed     | bool                                                    | Флаг, показывает управление пользователем вычислительной мощностью                                                                                                            |
| vgpus | []int                                                   | Список vgpu                                                                                                                                                                   |
| virtual_image_id | int                                                     | ID виртуального образа                                                                                                                                                        |
| boot_disk_id | int                                                     | Идентификатор загрузочного диска виртуальной машины.                                                                                                                          |
| boot_disk_size | int                                                     | Размер загрузочного диска в ГБ.                                                                                                                                               |
| sep_id | int                                                     | ID sep                                                                                                                                                                        |
| pool | string                                                  | Pool                                                                                                                                                                          |
| extra_disks | []int                                                   | Список идентификаторов дополнительных дисков, которые подключены к данной виртуальной машине помимо загрузочного диска. Если такие диски отсутствуют, то список будет пустым. |
| network | []Struct [см. ниже](#описание-структуры-network)                                  | Характеристики сетевых сегментов, к которым подключен данный сервер.                                                                                                          |

### Описание структуры network
| Параметр | Тип | Описание |
| --- | --- | --- |
| net_id | int | ID сети |
| net_type | string | Тип сети |
| ip_address | string | IP адрес |
| mac | string | MAC адрес |

### Описание структуры os users
| Параметр | Тип | Описание |
| --- | --- | --- |
| guid | string | GUID |
| login | string | Логин |
| password | string | Пароль |
| public_key | string | Публичный ssh ключ |

### Описание структуры tags
| Параметр | Тип | Описание |
| --- | --- | --- |
| key | string | Ключ тэга |
| val | string | Значение тэга |

### Описание структуры snap sets
| Параметр | Тип | Описание |
| --- | --- | --- |
| disks | []int | Список id дисков |
| guid | string | GUID |
| label | string | Лейбл |
| timestamp | int | Время |

### Описание структуры interfaces
| Параметр | Тип | Описание |
| --- | --- | --- |
| conn_id | int | ID connect |
| conn_type | string | Тип connect |
| def_gw | string | Шлюз по умолчанию |
| flip_group_id | int | id flip group |
| guid | string | GUID |
| ip_address | string | IP адрес |
| listen_ssh | bool | открыт ли ssh connect |
| mac | string | MAC адрес устройства |
| name | string | Имя |
| net_id | int | ID сети |
| netmask | int | Маска сети |
| net_type | string | Тип сети |
| pci_slot | int | Pci Slot |
| qos | []Struct{}[см. ниже](#описание-структуры-qos)| QOS |
| target | string | Цель сети |
| type | string | Тип |
| vnfs | []int | VNFS |

### Описание структуры qos
| Параметр | Тип | Описание |
| --- | --- | --- |
| e_rate | int | E rate |
| guid | string | ID ресурса |
| in_brust | int | In brust |
| in_rate | int | In rate |

### Описание структуры acl
| Параметр | Тип | Описание |
| --- | --- | --- |
| explicit | bool | Явно ли указан доступ |
| guid | string | guid Ресурса |
| right | string | Права на ресурс |
| status | string | Статус ресурса |
| type | string | Тип ресурса |
| user_group_id | string | ID user group |

### Описание структуры affinity rules
| Параметр | Тип | Описание |
| --- | --- | --- |
| guid | string | guid |
| key | string | Ключ |
| mode | string | Режим сравнения |
| policy | string | Степень "строгости" этого правила |
| topology | string | Топология |
| value | string | Значение |

### Описание структуры disks
| Параметр | Тип | Описание |
| --- | --- | --- |
| ckey | string | ckey |
| meta | []string | Мета информация |
| account_id | int | ID аккаунта |
| boot_partition | int | Загрузочный раздел |
| created_time | int | Время создания диска |
| deleted_time | int | Время удаления диска |
| desc | string | Описание |
| destruction_time | int | Время удаления |
| disk_path | string | Путь диска |
| gid | int | GID |
| guid | int | GUID |
| disk_id | int | ID диска |
| image_id | int | ID образа |
| images | []int | Список образов |
| iotune | Struct [см. ниже](#описание-структуры-iotune)| Ограничения диска |
| iqn | string | iqn диска |
| login | string | Логин для доступа к диску |
| milestones | int | Вехи |
| name | string | Наименование диска |
| order | int | Номер диска |
| params | string | Параметры диска |
| parent_id | int | id родительского диска |
| passwd | string | Пароль для доступа к диску |
| pci_slot | int | id pci слота, к которому подключен диск |
| pool | string | Имя пула в системе хранения, на ресурсах которой размещён данный диск |
| present_to | []int | Список ID ресурсов, которым предоставлен диск |
| purge_attempts        | int                                              | Кол-во попыток удаления                                                                                                                                                                                |
| purge_time | int | Время последней попытки |
| reality_device_number | int | Реальный номер устройства |
| reference_id | string | ID ссылки |
| res_id | int | id ресурса |
| res_name | string | Наименование ресурсов |
| role | string | Роль диска |
| sep_id | int | Идентификатор Storage Endpoint Provider (SEP). SEP это способ идентифицировать конкретную систему хранения, на ресурсах которой размещён данный диск |
| shareable | bool | Флаг, отвечающий за доступность диска дургим ресурсам |
| size_max | int | Размер диска в ГБ |
| size_used | float | Кол-во используемого места, в ГБ |
| snapshots | []Struct{}[см. ниже](#описание-структуры-snapshots)| Снимки состояния диска|
| status | string | Статус диска |
| tech_status | string | Технический статус диска |
| type | string | Тип диска с точки зрения его роли в составе _compute_. Может принимать одно из фиксированных значений:<br/>"B" - признак загрузочного диска ("boot").<br/>"D" - признак дополнительного диска ("data") |
| vmid | int | Идентификатор виртуальной машины (устаревшее) |

### Описание структуры iotune
| Параметр | Тип | Описание |
| --- | --- | --- |
| read_bytes_sec | int | Кол-во байт для чтения в секунду |
| read_bytes_sec_max | int | Максимальное кол-во байт для чтения |
| read_iops_sec | int | Кол-во операций чтения io в секунду | |
| read_iops_sec_max | int | Максимальное число io операций чтения |
| size_iops_sec | int | Размер io операций |
| total_bytes_sec | int | Общий размер байт в секунду |
| total_bytes_sec_max | int | Максимальный общий размер байт в секунду |
| total_iops_sec | int | Общее кол-во io операций в секунду |
| total_iops_sec_max | int | Максимальное общее кол-во io операций в секунду |
| write_bytes_sec | int | Кол-во байт для записи в секунду |
| write_bytes_sec_max | int | Максимальное кол-во байт для записи в секунду |
| write_iops_sec | int | Кол-во операций записи в секунду |
| write_iops_sec_max | int | Максимальное число операций записей |

### Описание структуры snapshots
| Параметр | Тип | Описание |
| --- | --- | --- |
| guid | string | id снимка |
| label | string | Наименование снимка |
| res_id | string | Ссылка на снимок |
| snap_set_guid | string | Установленный id снимка |
| snap_set_time | int | Установленное время снимка |
| timestamp | int | Время снимка |

## Пример использования
В нижеприведённом примере посредством вызова _data source_ функции **decort_cb_kvmvm** извлекается информация об уже существующем в платформе виртуальном сервере со следующими характеристиками:

```terraform
data "decort_cb_kvmvm" "existing_vm" {
  # id виртуальной машины
  # обязательный параметр
  # тип - число
  compute_id = 11346

  # прична запроса
  # опциональный параметр
  # тип - строка
  #reason = "test"
}
# Once the above directive completes, VM ID will be accessible 
# as data.decort_cb_kvmvm.existing_vm.id
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_kvmvm** в переменной `data.decort_cb_kvmvm.existing_vm` будут сохранены возвращаемые значения. Так, например:
* пароль для доступа в гостевую ОС, назначенный по умолчанию при создании VM - `"data.decort_cb_kvmvm.existing_vm.os_users.0.password`
* идентификатор образа ОС, на базе которого была создана данная VM - `data.decort_cb_kvmvm.existing_vm.image_id`
* текущий объём ОЗУ - `data.decort_cb_kvmvm.existing_vm.ram`
