Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_kvmvm_list** служит для получения информации о списке компьютов.

## Аргументы

_Data source_ функция **decort_cb_kvmvm_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| by_id | int | :x: | Фильтр по ID |
| name | string | :x: | Фильтр по имени |
| account_id | int | :x: | Фильтр по ID аккаунта |
| rg_id | int | :x: | Фильтр по ID ресурсной группы |
| rg_name | string | :x: | Фильтр по имени рес. группы |
| tech_status | string | :x: | Фильтр по тех.статусу |
| status | string | :x: | Фильтр по статусу |
| ip_address | string | :x: | Фильтр по IP адресу |
| extnet_name | string | :x: | Фильтр по имени внешней сети |
| extnet_id | int | :x: | Фильтр по extnet ID |
| includedeleted | bool| :x: | Включить в результат удаленные ресурсы |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |
| ignore_k8s | bool | :x: | При значении true - показать все ВМ, не относящиеся к любому из кластеров k8s |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_kvmvm_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип                                                     | Описание                                                                                                                                                                      |
| --- |---------------------------------------------------------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| account_id | int                                                     | Уникальный идентификатор подписчика-владельца ("account") данной виртуальной машины.                                                                                          |
| account_name | string                                                  | Имя подписчика, которому принадлежит данная виртуальная машина.                                                                                                               |
| acl | []Struct [см. ниже](#описание-структуры-acl)            | Cписок Acces Control                                                                                                                                                          |
| affinity_label | string                                                  | Лейбл аффинити                                                                                                                                                                |
| affinity_rules | []Struct [см. ниже](#описание-структуры-affinity-rules) | Правила аффинити для компьютов                                                                                                                                                |
| affinity_weight | int                                                     | weight аффинити                                                                                                                                                               |
| anti_affinity_rules | []Struct [см. ниже](#описание-структуры-affinity-rules) | Правила анти аффинити для компьютов                                                                                                                                           |
| arch | string                                                  | Архитектура                                                                                                                                                                   |
| boot_order | []string                                                | Boot order                                                                                                                                                                    |
| bootdisk_size | int                                                     | Размер загрузочного диска в ГБ.                                                                                                                                               |
|cd_image_id| int                                                     | cd image id                                                                                                                                                                   |
| clone_reference | int                                                     | кол-во клонов                                                                                                                                                                 |
| clones | []int                                                   | id клонов                                                                                                                                                                     |
| compute_id | int                                                     | Идентификатор экземпляра _compute_, соответствующего данной виртуальной машине.                                                                                               |
| computeci_id | int                                                     | ID вычислительного ресурса                                                                                                                                                    |
| cpus | int                                                     | Количество виртуальных CPU, выделенных данному серверу.                                                                                                                       |
| created_by | string                                                  | Кем создан _compute_                                                                                                                                                          |
| created_time | int                                                     | Время создания _compute_                                                                                                                                                      |
| custom_fields | string                                                  | Кастомные поля                                                                                                                                                                |
| deleted_by | string                                                  | Кем удален _compute_                                                                                                                                                          |
| deleted_time | int                                                     | Время удаления _compute_                                                                                                                                                      |
| desc | string                                                  | Текстовое описание виртуальной машины.                                                                                                                                        |
| devices | string                                                  | Девайсы                                                                                                                                                                       |
| disks | []Struct [см. ниже](#описание-структуры-disks)          | информация о дисках компьюта                                                                                                                                                  |
| driver | string                                                  | Аппаратная архитектура данной виртуальной машины.                                                                                                                             |
| gid | int                                                     | GRID ID                                                                                                                                                                       |
| guid | int                                                     | ID ресурса                                                                                                                                                                    |
| image_id | int                                                     | Идентификатор образа ОС, на базе которого создан загрузочный диск этой виртуальной машины.                                                                                    |
| interfaces | []Struct [см. ниже](#описание-структуры-interfaces)     | Информация о интерфейсах компьюта                                                                                                                                             |
| lock_status | string                                                  | Статус доступности                                                                                                                                                            |
| manager_id | int                                                     | Manager id                                                                                                                                                                    |
| manager_type | string                                                  | Type manager                                                                                                                                                                  |
| migrationjob | int                                                     | Migrationjob                                                                                                                                                                  |
| milestones | int                                                     | Вехи                                                                                                                                                                          |
| name | string                                                  | Имя компьюта                                                                                                                                                                  |
| need_reboot                  | bool                                                    | Флаг перезапуска                                                                                                                                                              |
| os_users                  | []Struct [см. ниже](#описание-структуры-os-users)       | Имена и пароли пользователей гостевой ОС, установленные платформой при создании виртуального сервера.                                                                         |
| pinned | bool                                                    | добавлен ли компьют на стек                                                                                                                                                   |
| ram | int                                                     | Объём оперативной памяти в МБ, выделенной этой виртуальной машине.                                                                                                            |
| reference_id | string                                                  | ID ссылки                                                                                                                                                                     |
| registered | bool                                                    | Компьют зарегестрирован                                                                                                                                                       |
| res_name | string                                                  | Наименование ресурса                                                                                                                                                          |
| rg_id | int                                                     | Идентификатор ресурсной группы, к которой принадлежит виртуальная машина.                                                                                                     |
| rg_name | string                                                  | Имя ресурсной группы, к которой принадлежит виртуальная машина.                                                                                                               |
| snap_sets | []Struct [см. ниже](#описание-структуры-snap-sets)      | Snap sets                                                                                                                                                                     |
| stack_id    | int                                                     | id стэка                                                                                                                                                                      |
| stateless_sep_id | int                                                     | ID сеп                                                                                                                                                                        |
| stateless_sep_type | string                                                  | Тип сеп                                                                                                                                                                       |
| status | string                                                  | Статус компьюта                                                                                                                                                               |
| tags | []Struct [см. ниже](#описание-структуры-tags)           | Тэги                                                                                                                                                                          |
| tech_status | string                                                  | Технический статус компьюта в составе группы                                                                                                                                  |
| total_disk_size | int | Размер диска |
| updated_by | string                                                  | Кем компьют был обновлен                                                                                                                                                      |
| updated_time | int                                                     | Время последнего обновления                                                                                                                                                   |
|user_data| string                                                  | Данные пользователя                                                                                                                                                           |
| user_managed     | bool                                                    | Флаг, показывает управление пользователем вычислительной мощностью                                                                                                            |
| vgpus | []int                                                   | Список vgpu                                                                                                                                                                   |
| vins_connected | int | Кол-во присоединенных винсов |
| virtual_image_id | int                                                     | ID виртуального образа                                                                                                                                                        |

### Описание структуры os users
| Параметр | Тип | Описание |
| --- | --- | --- |
| guid | string | GUID |
| login | string | Логин |
| password | string | Пароль |
| public_key | string | Публичный ssh ключ |

### Описание структуры tags
| Параметр | Тип | Описание |
| --- | --- | --- |
| key | string | Ключ тэга |
| val | string | Значение тэга |

### Описание структуры snap sets
| Параметр | Тип | Описание |
| --- | --- | --- |
| disks | []int | Список id дисков |
| guid | string | GUID |
| label | string | Лейбл |
| timestamp | int | Время |

### Описание структуры interfaces
| Параметр | Тип | Описание |
| --- | --- | --- |
| conn_id | int | ID connect |
| conn_type | string | Тип connect |
| def_gw | string | Шлюз по умолчанию |
| flip_group_id | int | id flip group |
| guid | string | GUID |
| ip_address | string | IP адрес |
| listen_ssh | bool | открыт ли ssh connect |
| mac | string | MAC адрес устройства |
| name | string | Имя |
| net_id | int | ID сети |
| netmask | int | Маска сети |
| net_type | string | Тип сети |
| pci_slot | int | Pci Slot |
| qos | []Struct{}[см. ниже](#описание-структуры-qos)| QOS |
| target | string | Цель сети |
| type | string | Тип |
| vnfs | []int | VNFS |

### Описание структуры qos
| Параметр | Тип | Описание |
| --- | --- | --- |
| e_rate | int | E rate |
| guid | string | ID ресурса |
| in_brust | int | In brust |
| in_rate | int | In rate |

### Описание структуры acl
| Параметр | Тип | Описание |
| --- | --- | --- |
| explicit | bool | Явно ли указан доступ |
| guid | string | guid Ресурса |
| right | string | Права на ресурс |
| status | string | Статус ресурса |
| type | string | Тип ресурса |
| user_group_id | string | ID user group |

### Описание структуры affinity rules
| Параметр | Тип | Описание |
| --- | --- | --- |
| guid | string | guid |
| key | string | Ключ |
| mode | string | Режим сравнения |
| policy | string | Степень "строгости" этого правила |
| topology | string | Топология |
| value | string | Значение |

### Описание структуры disks
| Параметр | Тип | Описание |
| --- | --- | --- |
| disk_id | int | id диска |
| pci_slot | int | id pci слота, к которому подключен диск |

## Пример использования
```terraform
data "decort_cb_kvmvm_list" "kvmvm_list" {
  #фильтр по id ВМ
  #опциональный параметр
  #тип - число
  #by_id = 100

  #фильтр по имени ВМ
  #опциональный параметр
  #тип - строка
  #name = "test"

  #id аккаунта для получения списка ВМ
  #опциональный параметр 
  #тип - число
  #account_id = 11111

  #фильтр по имени ресурсной группы
  #опциональный параметр
  #тип - строка
  #rg_name = "test"

  #фильтр по id ресурсной группы
  #опциональный параметр
  #тип - число
  #rg_id = 100

  #фильтр по техническому статусу
  #опциональный параметр
  #тип - строка
  #tech_status = "STOPPED"

  #фильтр по статусу
  #опциональный параметр
  #тип - строка
  #status = "ENABLED"

  #фильтр по ip
  #опциональный параметр
  #тип - строка
  #ip_address = "test"

  #фильтр по имени extnet
  #опциональный параметр
  #тип - строка
  #extnet_name = "test"

  #фильтр по id extnet
  #опциональный параметр
  #тип - число
  #extnet_id = 100

  #флаг влючения в результат удаленных балансироващиков нагрузки
  #опциональный параметр
  #тип - булев тип
  #значение по-умолчанию - false
  #если не задан - выводятся все доступные неудаленные балансировщики
  #includedeleted = true

  #номер страницы для отображения
  #опциональный параметр
  #тип - число
  #если не задан - выводятся все доступные данные
  #page = 1

  #размер страницы
  #опциональный параметр
  #тип - число
  #если не задан - выводятся все доступные данные
  #size = 1

  #Включить в список вывода ВМ, принадлежащие k8s кластерам (при значении параметра true)
  #опциональный параметр
  #bool (default = false)
  #ignore_k8s = true
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова _data source_ функции **decort_cb_kvmvm_list** в переменной `data.decort_cb_kvmvm_list.kvmvm_list` будут сохранены возвращаемые значения.
