Функция доступна в провайдере версии 4.5.1 и выше.

_Resource_ функция **decort_cb_extnet_static_route** служит для управления статическим маршрутом для внешней сети.

## Аргументы
_Resource_ функция **decort_cb_extnet_static_route** принимает следующие аргументы:

| Аргумент | Тип    | Обязательный       | Описание                                                               |
|----------|--------|--------------------|------------------------------------------------------------------------|
| extnet_id  | int    | :heavy_check_mark: | ID сети extnet                                                         |
| destination | string | :heavy_check_mark: | IP-адрес сети назначения                                               |
| gateway | string | :heavy_check_mark: | Шлюз по умолчанию. IP-адрес из пула свободных IP-адресов сети.         |
| netmask | string | :heavy_check_mark: | Маска сети назначения в формате 255.255.255.255                        |
| compute_ids   | []int  | :x:                | Список ID виртуальных машин, которым предоставляется доступ к маршруту |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_extnet_static_route** возвращает в указанную при вызове переменную следующие значения:

| Параметр    | Тип    | Описание                                       |
|-------------|--------|------------------------------------------------|
| extnet_id  | int    | ID сети extnet                             |
| compute_ids | []int  | Список ID compute, которым предоствавлен доступ |
| route_id    | int    | ID статического маршрута                       |
| guid        | string | ID ресурса                                     |
| destination | string | IP целевой сети                                |
| netmask     | string    | Маска сети                                     |
| gateway     | string | IP шлюза                                       |

## Пример использования
Пример вызова _data source_ функции **decort_cb_extnet_static_route**:

```terraform
resource "decort_cb_extnet_static_route "my_route" {
  extnet_id = 385
  destination = "192.168.201.0"
  netmask  =   "255.255.255.255"
  gateway = "192.168.201.40"
  #compute_ids = [111,222]
}
# Once the above directive completes, extnet static route id will be accessible as
# decort_cb_extnet_static_route.my_route.route_id
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.2/04.02-Инициализация-Terraform-провайдера-DECORT.md) и [пример](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.2/02.-Пример-работы.md)). 

После успешного завершения такого вызова **decort_cb_extnet_static_route** в переменной `data.decort_cb_extnet_static_route.my_route` будут сохранены возвращаемые значения.
