Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_kvmvm_vgpu_list** служит для получения информации о доступных компьюту списка виртуальных графических устройств.

## Аргументы
_Data source_ функция **decort_cb_kvmvm_vgpu_list** принимает следующие аргументы:

| Аргумент | Тип    | Обязательный                    | Описание                                |
| --- |--------|---------------------------------|-----------------------------------------|
| compute_id | int    | :heavy_check_mark: |  id компьюта                            |
| gpu_id | int    | :x:                             | Фильтр по ID устройства                 |
| type | string | :x:                             | Фильтр по типу графического устройства  |
| status | string | :x:                             | Фильтр по статусу                       |
| includedeleted | bool   | :x:                             | Включить в рез-тат удаленные устройства |
| page | int    | :x:                             | Номер страниц                           |
| size | int    | :x:                             | Размер страницы                         |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_kvmvm_vgpu_list** возвращает в указанную при вызове переменную, в поле _items_ массив строк.

## Пример использования
Пример вызова _data source_ функции **decort_cb_kvmvm_vgpu_list**:
```terraform
data "decort_cb_kvmvm_vgpu_list" "vgpu_list" {
  #id виртуальной машины
  #обязательный параметр
  #тип - число
  compute_id = 100
 
  #фильтр по id графического процессора
  #опциональный параметр
  #тип - число
  #gpu_id = 100

  #фильтр по типу графического процессора
  #опциональный параметр
  #тип - строка
  #type = "NVIDIA"

  #фильтр по статусу
  #опциональный параметр
  #тип - строка
  #status = "ENABLED"

  #фильтр "включая удаленные графические процессоры"
  #опциональный параметр
  #тип - булев тип
  #includedeleted = "false"

  #номер страницы для отображения
  #опциональный параметр
  #тип - число
  #если не задан - выводятся все доступные данные
  #page = 1

  #размер страницы
  #опциональный параметр
  #тип - число
  #если не задан - выводятся все доступные данные
  #size = 1
}
# once the above directive completes, decort_cb_kvmvm_vgpu_list list will be accessible 
# as data.decort_cb_kvmvm_vgpu_list.vgpu_list.items
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_kvmvm_vgpu_list** в переменной `data.decort_cb_kvmvm_vgpu_list.vgpu_list.items` будут сохранены возвращаемые значения.
