Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_rg_affinity_groups_get** служит для получения информации о аффинити группе ресурсной группы.

Ресурсная группа в облачной платформе DECORT это способ группирования _compute_-ов (например, по функциональному признаку или принадлежности к одному и тому же проекту). Ресурсную группу можно рассматривать как небольшой персональный дата-центр, в котором размещаются один или несколько серверов и виртуальных сетевых сегментов (ViNS).

Экземпляры _compute_ (виртуальные серверы) всегда создаются в принадлежности к какой-либо ресурсной группе. Как следствие, для создания экземпляра _compute_ помимо других параметров требуется указать идентификатор целевой ресурсной группы. Для получения такого идентификатора можно воспользоваться рассматриваемой здесь _data source_ функцией **decort_cb_rg_affinity_groups_get**.

## Аргументы
_Data source_ функция **decort_cb_rg_affinity_groups_get** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| rg_id | int | :heavy_check_mark: | Идентификатор ресурсной группы |
| affinity_group | string | :heavy_check_mark: | Аффинити группа |

Пользователь облачной платформы, от лица которого происходит обращение к данной функции, должен иметь доступ к указанному `account` и ресурсной группе. В противном случае возникнет ошибка доступа.

Пользователь облачной платформы задается на стадии инициализации Terraform провайдера DECORT (см. [подробности](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_rg_affinity_groups_get** возвращает следующие параметры:

| Параметр | Тип | Описание |
| --- | --- | --- |
| ids | []int | Список ID виртуальных машин в указанной affinity группе. |

## Пример использования
Пример вызова _data source_ функции **decort_cb_rg_affinity_groups_get**:

```terraform
data "decort_cb_rg_affinity_groups_get" "rg_affinity_groups_get" {
  #id ресурсной группы
  #обязательный параметр
  #тип - целое число
  rg_id = 1234

  #название специальной группы компьютов
  #обязательное поле
  #тип - строка
  affinity_group = "TEST"
}
# Once the above directive completes, resource group affinity groups ids will be accessible as
# data.decort_cb_rg_affinity_groups_get.rg_affinity_groups_get.ids
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.0/04.02-Инициализация-Terraform-провайдера-DECORT.md) и [пример](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.0/02.-Пример-работы.md)). 

После успешного завершения такого вызова **decort_cb_rg_affinity_groups_get** в переменной `data.decort_cb_rg_affinity_groups_get.rg_affinity_groups_get` будут сохранены возвращаемые значения. В частности, для получения идентификатора ресурсной группы следует использовать конструкцию `data.decort_cb_rg_affinity_groups_get.rg_affinity_groups_get.ids`
