Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_vins_static_route** служит для получения статического маршрута для внутренней сети vins.

## Аргументы
_Data source_ функция **decort_cb_vins_static_route** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| vins_id | int | :heavy_check_mark: | ID внутренней сети |
| route_id | int | :heavy_check_mark: | ID статического маршрута |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_vins_static_route** возвращает в указанную при вызове переменную, которая состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| compute_ids | []int | Список ID compute, которым предоствавлен доступ |
| route_id | int | ID статического маршрута |
| vins_id | int | ID внутренней сети |
| guid | int | ID ресурса |
| destination | string | IP целевой сети |
| netmask | int | Маска сети |
| gateway | string | IP шлюза |

## Пример использования
Пример вызова _data source_ функции **decort_cb_vins_static_route**:
```terraform
data "decort_cb_vins_static_route" "sr" {
  #id vins в котором добавлены routes
  #обязательный параметр
  #тип - целое число
  vins_id = 10101

  #id route
  #обязательный параметр
  #тип - целое число
  route_id = 1
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.1/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_vins_static_route** в переменной `data.decort_cb_vins_static_route.sr` будут сохранены возвращаемые значения.
