Функция доступна в провайдере версии 3.5.0 и выше.

_Data source_ функция **decort_kvmvm_get_log** служит для получения логов по заданному пути компьюта.

## Аргументы

_Data source_ функция **decort_kvmvm_get_log** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| compute_id | int | :heavy_check_mark: | ID компьюта |
| path | string | :heavy_check_mark: | путь до файла |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_kvmvm_get_log** возвращает в указанную при вызове переменную следующие значения:
| Параметр | Тип | Описание |
| --- | --- | --- |
| log | string | логи |

## Пример использования
```terraform
data "decort_kvmvm_get_log" "kvmvm_get_log" {
  #id виртуальной машины
  #обязательный параметр
  #тип - целое число
  compute_id = 10154

  #путь до log файла
  #обязательный параметр
  #тип - строка
  path = "/var/log/file.log"
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова _data source_ функции **decort_kvmvm_get_log** в переменной `data.decort_kvmvm_get_log.kvmvm_get_log` будут сохранены возвращаемые значения.
