Функция доступна в провайдере версии 4.4.1 и выше.

_Data source_ функция **decort_kvmvm_vgpu_list** служит для получения информации о доступных компьюту списка виртуальных графических устройств.

## Аргументы
_Data source_ функция **decort_kvmvm_vgpu_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| compute_id | int | :heavy_check_mark: | id компьюта |
| gpu_id | int | :x: | Фильтр по ID устройства |
| type | int | :x: | Фильтр по типу графического устройства |
| status | string | :x: | Фильтр по статусу |
| includedeleted | bool | :x: | Включить в рез-тат удаленные устройства |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_kvmvm_vgpu_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | id аккаунта, которому принадлежит устройство |
| created_time | int | Время создания устройства |
| deleted_time | int | Время удаления устройства |
| gid | int | Grid ID |
| guid | int | guid устройства |
| vgpu_id | int | ID устройства |
| last_claimed_by | int | last claimed by |
| last_update_time | int | Время обновления устройства |
| mode | string | Режим устройства |
| pci_slot | int | Слот pci |
| pgpuid | int | pgpu id |
| profile_id | int | ID профиля |
| ram | int | Количество RAM |
| reference_id | string | ID ссылки |
| rg_id | int | ID ресурсной группы |
| status | string | Статус устройства |
| type | string | Тип устройства |
| vm_id | int | ID виртуальной машины |

## Пример использования
Пример вызова _data source_ функции **decort_kvmvm_vgpu_list**:
```terraform
data "decort_kvmvm_vgpu_list" "vgpu_list" {
  #id виртуальной машины
  #обязательный параметр
  #тип - целое число
  compute_id = 100
 
  #фильтр по id графического процессора
  #опциональный параметр
  #тип - целое число
  #gpu_id = 100

  #фильтр по типу графического процессора
  #опциональный параметр
  #тип - строка
  #type = "NVIDIA"

  #фильтр по статусу
  #опциональный параметр
  #тип - строка
  #status = "ENABLED"

  #фильтр "включая удаленные графические процессоры"
  #опциональный параметр
  #тип - булев
  #includedeleted = "false"

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #номер страницы для отображения
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #page = 1

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #size = 1
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_kvmvm_vgpu_list** в переменной `data.decort_kvmvm_vgpu_list.vgpu_list` будут сохранены возвращаемые значения.
