Функция доступна в версии провайдера 4.5.1 и выше.

_Data source_ функция **decort_cb_kvmvm_affinity_relations** служит для получения словаря ВМ разделенного по правилам affinity и anti-affinity.

## Аргументы
_Data source_ функция **decort_cb_kvmvm_affinity_relations** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| compute_id | int | :heavy_check_mark: | Идентификатор экземпляра _compute_, соответствующего данной виртуальной машине (подробнее о понятии _compute_ см. в разделе [Обзор облачной платформы DECORT](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.3/03.-Обзор-облачной-платформы-DECORT.md)). |

Пользователь облачной платформы, от лица которого происходит обращение к данной функции, должен иметь доступ к указанному виртуальному серверу и ресурсной группе. В противном случае возникнет ошибка доступа.

Пользователь облачной платформы задается на стадии инициализации Terraform провайдера DECORT (см. [подробности](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_kvmvm_affinity_relations** возвращает в указанную при вызове переменную следующие значения:

| Параметр | Тип | Описание |
| --- | --- | --- |
| compute_id | int | ID виртуальной машины |
| other_node | []string | Спсиок other node |
| other_node_indirect | []string | Список other node indirect |
| other_node_indirect_soft | []string | Список other node indirect soft |
| other_node_soft | []string | Список other node soft |
| same_node | []string | Список same node |
| same_node_soft | []string | Список same node soft |

## Пример использования
В нижеприведённом примере посредством вызова _data source_ функции **decort_cb_kvmvm_affinity_relations** извлекается информация об уже существующем в платформе виртуальном сервере со следующими характеристиками:

```terraform
data "decort_cb_kvmvm_affinity_relations" "relations" {
  #id виртуальной машины
  #обязательный параметр
  #тип - целое число
  compute_id = 11346
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_kvmvm_affinity_relations** в переменной `data.decort_cb_kvmvm_affinity_relations.relations` будут сохранены возвращаемые значения.
