Функция доступна в провайдере версии 3.5.0 и выше.

_Data source_ функция **decort_kvmvm_pfw_list** служит для получения списка pfw компьюта.

## Аргументы

_Data source_ функция **decort_kvmvm_pfw_list** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| compute_id | int | :heavy_check_mark: | ID компьюта |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_kvmvm_pfw_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| pfw_id | int | ID pfw |
| local_ip | string | Локальный ip адрес |
| local_port | int | Локальный порт |
| protocol | string | Протокол tcp/udp |
| public_port_end | int | Конец диапазона внешних портов |
| public_port_start | int | Начало диапазона внешних портов |
| vm_id | int | ID компьюта |

## Пример использования
```terraform
data "decort_kvmvm_pfw_list" "kvmvm_pfw_list" {
  #id виртуальной машины
  #обязательный параметр
  #тип - целое число
  compute_id = 10524
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.4/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова _data source_ функции **decort_kvmvm_pfw_list** в переменной `data.decort_kvmvm_pfw_list.kvmvm_pfw_list` будут сохранены возвращаемые значения. 
