Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_flipgroup_list** служит для получения информации о всех группах с плавающим ip-адресом.

## Аргументы

_Data source_ функция **decort_cb_flipgroup_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| name | string | :x: | Фильтр по названию группы с плавающим ip-адресом (flipgroup) |
| account_id | int | :x: | Фильтр по ID аккаунта |
| conn_id | int | :x: | Фильтр по ID подключения |
| status | string | :x: | Фильтр по статусу плавающей группы |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| vins_id | int | :x: | Фильтр по ID виртуальной сети |
| vins_name | string | :x: | Фильтр по названию виртуальной сети |
| extnet_id | int | :x: | Фильтр по ID внешней сети |
| by_ip | string | :x: | Фильтр по ip-адресу |
| rg_id | int | :x: | Фильтр по ID ресурсной группы |
| client_ids | []int | :x: | Фильтр по ID клиентов группы |
| by_id | int | :x: | Фильтр по ID группы с плавающим ip-адресом |
| page | int | :x: | Номер страницы для вывода |
| size | int | :x: | Размер страницы для вывода |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_flipgroup_list** возвращает в указанную при вызове переменную, в поле _items_, массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| ckey | string | CKey |
| meta | []string | Мета информация |
| account_id | int | ID аккаунта - владельца группы с плавающим ip-адресом |
| client_ids | []int | Список ID клиентов группы с плавающим ip-адресом |
| client_type | string | Тип клиента |
| conn_id | int | ID подключения |
| conn_type | string | Тип подключения |
| default_gw | string | Шлюз по умолчанию |
| description | string | Описание группы |
| gid | int | Идентификатор площадки (grid id) |
| guid | int | ID ресурса |
| flipgroup_id | int | ID группы с плавающим ip-адресом |
| ip | string | IP адрес |
| milestones | int | Вехи |
| name | string | Название группы с плавающим ip-адресом |
| net_id | int | ID сети |
| net_type | string | Тип сети |
| net_mask | int | Маска подсети |
| status | string | Статус группы с плавающим ip-адресом |

## Пример использования

Пример вызова _data source_ функции **decort_cb_flipgroup_list**:

```terraform
data "decort_cb_flipgroup_list" "fgl" {
  #фильтр по id flipgroup 
  #опциональный параметр
  #тип - целое число
  #by_id = 100

  #фильтр по имени flipgroup
  #опциональный параметр
  #тип - строка
  #name = "test"

  #фильтр по id vins
  #опциональный параметр
  #тип - целое число
  #vins_id = 100

  #фильтр по имени vins
  #опциональный параметр
  #тип - строка
  #vins_name = "test"

  #фильтр по id extnet
  #опциональный параметр
  #тип - целое число
  #extnet_id = 100

  #фильтр по IP
  #опциональный параметр
  #тип - строка
  #by_ip = "1.1.1.1.1"

  #фильтр по id ресурсной группы
  #опциональный параметр
  #тип - целое число
  #rg_id = 11111

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #номер страницы для отображения
  #опциональный параметр
  #если не задан - выводятся все доступные данные
  #тип - целое число
  #page = 2

  #размер страницы
  #опциональный параметр
  #если не задан - выводятся все доступные данные
  #тип - целое число
  #size = 3

  #фильтр по id аккаунта
  #опциональный параметр
  #тип - целое число
  #account_id = 100

  #фильтр по id conn
  #опциональный параметр
  #тип - целое число
  #conn_id = 100

  #фильтр по id клиентов
  #опциональный параметр
  #тип - массив целых чисел
  #client_ids = [10,11]

  #фильтр по статусу
  #опциональный параметр
  #тип - строка
  #status = "CREATED"
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_flipgroup_list** в переменной `data.decort_cb_flipgroup_list.fgl.items` будут сохранены возвращаемые значения.
