Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_account_deleted_list** служит для получения информации об удаленных аккаунтах, которые можно восстановить в дальнейшем. В данный список попадают аккаунты, удаленные с флагом permanently, выставленным в false.

## Аргументы
_Data source_ функция **decort_account_deleted_list** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| by_id | int | :x: | Фильтр по ID аккаунта |
| name | string | :x: | Фильтр по имени аккаунта |
| acl | string | :x: | Фильтр по ACL |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страницы |
| size | int | :x: | Размер страницы |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_account_deleted_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта |
| account_name | string | Название аккаунта |
| acl | []Struct{<br/>explicit bool<br/>guid string<br/>right string<br/>status string<br/>type string<br/>user_group_id string<br/>} | Более подробная информация об аккаунтах<br/>Явно ли указан доступ<br/>guid аккаунта<br/>Права доступа<br/>Статус аккаунта<br/>Тип аккаунта<br/>Идентификатор пользователя-владельца аккаунта<br/>&nbsp;<br/> |
| compute_features | []string | Доступ к дополнительным функциям управления ВМ |
| created_time | int | Время создания аккаунта |
| deleted_time | int | Время удаления аккаунта |
| status | string | Статус аккаунта |
| updated_time | int | Время последнего обновления |

## Пример использования
Пример вызова _data source_ функции **decort_account_deleted_list**:
```terraform
data "decort_account_deleted_list" "adl" {
  #номер страницы для отображения
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #page = 2

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #size = 3

  #фильтр по id аккаунта
  #опциональный параметр
  #тип - целое число
  #by_id = 100

  #фильтр по имени аккаунта
  #опциональный параметр
  #тип - строка
  #name = "test"

  #фильтр по ACL
  #опциональный параметр
  #тип - строка
  #acl = "test"

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.1/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_account_deleted_list** в переменной `data.decort_account_deleted_list.adl` будут сохранены возвращаемые значения.
