_Data source_ функция **decort_k8ci_list** служит для получения информации о доступных k8ci

## Аргументы

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| by_id | int | :x: | Фильтр по ID k8ci |
| name | string | :x: | Фильтр по имени |
| status | string | :x: | Фильтр по статусу |
| worker_driver | string | :x: | Фильтр по драйверу worker |
| master_driver | string | :x: | Фильтр по драйверу master |
| network_plugin | string | :x: | Фильтр по плагину сети (flannel, calico или weavenet) |
| include_disabled | bool | :x: | Дополнить рез-тат выключенными k8ci |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страницы |
| size | int | :x: | Размер страницы |

## Возвращаемые значения (в списке items)

| Параметр | Тип | Описание |
| --- | --- | --- |
| k8ci_id | int | ID k8ci |
| name | string | Наименование k8ci |
| lb_image_id | int | ID образа балансировщика |
| network_plugins | []string | Список доступных плагинов сети |
| status | string | Статус |
| desc | string | Описание |
| created_time | int | Время создания |
| version | string | Версия |

## Пример использования

```terraform
data "decort_k8ci_list" "k8ci_list" {
  #поиск по ID
  #опциональный параметр
  #тип - целое число
  by_id = 12

  #поиск по наименованию
  #опциональный параметр
  #тип - строка
  name = "name"

  #поиск по статус
  #опциональный параметр
  #тип - строка
  status = "status"

  #поиск по worker драйверу
  #опциональный параметр
  #тип - строка
  worker_driver = "wdriver"

  #поиск по master драйверу
  #опциональный параметр
  #тип - строка
  master_driver = "wdriver"

  #поиск по network плагину
  #опциональный параметр
  #тип - строка
  network_plugin = "flannel"

  #показать выключенные K8CI
  #опциональный параметр
  #тип - булев
  include_disabled = true

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  sort_by = "+name"

  #номер страницы
  #опциональный параметр
  #тип - целое число
  page = 1

  #размер страницы
  #опциональный параметр
  #тип - целое число
  size = 5
}
```

После успешного завершения такого вызова **decort_k8ci_list** в переменной `data.decort_k8ci_list.k8ci_list` будут сохранены возвращаемые значения.
