Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_k8s_wg_list** служит для получения информации о списке групп воркеров кластера Kubernetes (k8s).

## Аргументы

_Data source_ функция **decort_cb_k8s_wg_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| k8s_id | int | :heavy_check_mark: | ID кластера |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_k8s_wg_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| annotations | []string | Аннотации ресурса |
| cpu | int | Кол-во cpu на нодах |
| detailed_info | []Struct{} [см. ниже](#описание-структуры-списка-detailed_info) | Детальная информация masters |
| disk | int | ID диска |
| guid | string | ID ресурса |
| wg_id | int | ID группы воркеров кластера |
| labels | []string | Лейблы ресурса |
| name | string | Имя группы воркеров |
| num | int | кол-во компьютов в ресурсе |
| ram | int | Кол-во ram на нодах |
| taints | []string | ограничители группы workers |

### Описание структуры списка detailed_info

| Параметр | Тип | Описание |
| --- | --- | --- |
| external_ip | string | Внешний ip - адрес |
| compute_id | int | ID компьюта в составе группы |
| name | string | Имя компьюта в составе группы |
| status | string | Статус компьюта в составе группы |
| tech_status | string | Технический статус компьюта в составе группы |
| interfaces | []Struct{} [см. ниже](#описание-структуры-списка-interfaces) | Список интерфейсов группы |

### Описание структуры списка interfaces

| Параметр | Тип | Описание |
| --- | --- | --- |
| def_gw | string | Шлюз по умолчанию |
| ip_address | string | IP интерфейса |

## Пример использования

Пример вызова _data source_ функции **decort_cb_k8s_wg_list**:

```terraform
data "decort_cb_k8s_wg_list" "k8s_wg_list" {
  #id кластера
  #обязательный параметр
  #тип - целое число
  k8s_id = 49304
}
```

После успешного завершения такого вызова **decort_cb_k8s_wg_list** в переменной `data.decort_cb_k8s_wg_list.k8s_wg_list` будут сохранены возвращаемые значения.

