Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_disk_list_types** служит для получения информации о типах диска.

## Аргументы
_Data source_ функция **decort_cb_disk_list_types** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_disk_list_types** возвращает в указанную при вызове переменную следующие значения:

| Параметр | Тип | Описание |
| --- | --- | --- |
| items | []string | Список всех доступных типов дисков |

## Пример использования
Пример вызова _data source_ функции **decort_cb_disk_list_types**:

```terraform
data "decort_cb_disk_list_types" "dlt" {
  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #тип - строка
  #sort_by = "+name"

  #номер страницы для отображения
  #опциональный параметр
  #если не задан - выводятся все доступные данные
  #тип - целое число
  #page = 2

  #размер страницы
  #опциональный параметр
  #если не задан - выводятся все доступные данные
  #тип - целое число
  #size = 3
}
```

После успешного завершения такого вызова **decort_cb_disk_list_types** в переменной `data.decort_cb_disk_list_types.dt.items` будут сохранены возвращаемые значения.
